// Generated IDL File (by Great Migrations Studio) 
// Created: 12/3/2025 09:38:31 AM
// Source: C:\Windows\SysWow64\COMDLG32.OCX
// typelib filename: COMDLG32.OCX
[
    uuid(F9043C88-F6F2-101A-A3C9-08002B2F49FB),
    version(1.2),
    helpstring("Microsoft Common Dialog Control 6.0 (SP3)"),
    helpfile("C:\windows\HELP\cmdlg98.chm"),
    helpcontext(0x00030d40),
    control
]
library MSComDlg
{
    // TLib : OLE Automation : {00020430-0000-0000-C000-000000000046}
    importlib("stdole2.tlb");

    // Forward declare all types defined in this typelib

    interface ICommonDialog;
    dispinterface ICommonDialogEvents;
    coclass CommonDialog;

    typedef [uuid(05428B50-E613-11CD-A2D5-08002B336F60), helpstring("Printer Dialog Box Constants"), helpcontext(0x00030d41)]
    enum {
        cdlPDAllPages = 0,
        cdlPDCollate = 16,
        cdlPDDisablePrintToFile = 0x00080000,
        cdlPDHidePrintToFile = 0x00100000,
        cdlPDNoPageNums = 8,
        cdlPDNoSelection = 4,
        cdlPDNoWarning = 128,
        cdlPDPageNums = 2,
        cdlPDPrintSetup = 64,
        cdlPDPrintToFile = 32,
        cdlPDReturnDC = 256,
        cdlPDReturnDefault = 1024,
        cdlPDReturnIC = 512,
        cdlPDSelection = 1,
        cdlPDHelpButton = 2048,
        cdlPDUseDevModeCopies = 0x00040000
    } PrinterConstants;

    typedef [uuid(05428B51-E613-11CD-A2D5-08002B336F60), helpstring("Color Dialog Box Constants"), helpcontext(0x00030d52)]
    enum {
        cdlCCRGBInit = 1,
        cdlCCFullOpen = 2,
        cdlCCPreventFullOpen = 4,
        cdlCCHelpButton = 8
    } ColorConstants;

    typedef [uuid(05428B52-E613-11CD-A2D5-08002B336F60), helpstring("File Open/Save Dialog Box Constants"), helpcontext(0x00030d57)]
    enum {
        cdlOFNReadOnly = 1,
        cdlOFNOverwritePrompt = 2,
        cdlOFNHideReadOnly = 4,
        cdlOFNNoChangeDir = 8,
        cdlOFNHelpButton = 16,
        cdlOFNNoValidate = 256,
        cdlOFNAllowMultiselect = 512,
        cdlOFNExtensionDifferent = 1024,
        cdlOFNPathMustExist = 2048,
        cdlOFNFileMustExist = 4096,
        cdlOFNCreatePrompt = 8192,
        cdlOFNShareAware = 16384,
        cdlOFNNoReadOnlyReturn = 32768,
        cdlOFNNoLongNames = 0x00040000,
        cdlOFNExplorer = 0x00080000,
        cdlOFNNoDereferenceLinks = 0x00100000,
        cdlOFNLongNames = 0x00200000
    } FileOpenConstants;

    typedef [uuid(05428B53-E613-11CD-A2D5-08002B336F60), helpstring("Fonts Dialog Box Constants"), helpcontext(0x00030d68)]
    enum {
        cdlCFScreenFonts = 1,
        cdlCFPrinterFonts = 2,
        cdlCFBoth = 3,
        cdlCFHelpButton = 4,
        cdlCFEffects = 256,
        cdlCFApply = 512,
        cdlCFANSIOnly = 1024,
        cdlCFNoVectorFonts = 2048,
        cdlCFNoSimulations = 4096,
        cdlCFLimitSize = 8192,
        cdlCFFixedPitchOnly = 16384,
        cdlCFWYSIWYG = 32768,
        cdlCFForceFontExist = 0x00010000,
        cdlCFScalableOnly = 0x00020000,
        cdlCFTTOnly = 0x00040000,
        cdlCFNoFaceSel = 0x00080000,
        cdlCFNoStyleSel = 0x00100000,
        cdlCFNoSizeSel = 0x00200000
    } FontsConstants;

    typedef [uuid(05428B54-E613-11CD-A2D5-08002B336F60), helpstring("Common Dialog Error Constants"), helpcontext(0x00030d7b)]
    enum {
        cdlInvalidPropertyValue = 380,
        cdlGetNotSupported = 394,
        cdlSetNotSupported = 383,
        cdlAlloc = 32752,
        cdlCancel = 32755,
        cdlDialogFailure = 0xffff8000,
        cdlFindResFailure = 32761,
        cdlHelp = 32751,
        cdlInitialization = 32765,
        cdlLoadResFailure = 32760,
        cdlLoadStrFailure = 32762,
        cdlLockResFailure = 32759,
        cdlMemAllocFailure = 32758,
        cdlMemLockFailure = 32757,
        cdlNoFonts = 24574,
        cdlBufferTooSmall = 20476,
        cdlInvalidFileName = 20477,
        cdlSubclassFailure = 20478,
        cdlCreateICFailure = 28661,
        cdlDndmMismatch = 28662,
        cdlGetDevModeFail = 28666,
        cdlInitFailure = 28665,
        cdlLoadDrvFailure = 28667,
        cdlNoDefaultPrn = 28663,
        cdlNoDevices = 28664,
        cdlParseFailure = 28669,
        cdlPrinterCodes = 28671,
        cdlPrinterNotFound = 28660,
        cdlRetDefFailure = 28668,
        cdlSetupFailure = 28670,
        cdlNoTemplate = 32764,
        cdlNoInstance = 32763,
        cdlInvalidSafeModeProcCall = 680
    } ErrorConstants;

    typedef [uuid(05428B55-E613-11CD-A2D5-08002B336F60), helpstring("Help Constants"), helpcontext(0x00030d97)]
    enum {
        cdlHelpContext = 1,
        cdlHelpQuit = 2,
        cdlHelpIndex = 3,
        cdlHelpContents = 3,
        cdlHelpHelpOnHelp = 4,
        cdlHelpSetIndex = 5,
        cdlHelpSetContents = 5,
        cdlHelpContextPopup = 8,
        cdlHelpForceFile = 9,
        cdlHelpKey = 257,
        cdlHelpCommandHelp = 258,
        cdlHelpPartialKey = 261
    } HelpConstants;

    typedef [uuid(DE7CF09C-0E9A-11D1-8B7A-0000F8754DA1), helpstring("Printer Orientation Constants"), helpcontext(0x00030dff)]
    enum {
        cdlPortrait = 1,
        cdlLandscape = 2
    } PrinterOrientationConstants;

    [
        odl,
        uuid(083039C2-13F4-11D1-8B7E-0000F8754DA1),
        helpstring("Microsoft Common Dialog Control 6.0 (SP3)"),
        helpcontext(0x00030d40),
        hidden,
        dual,
        nonextensible,
        oleautomation
    ]
    interface ICommonDialog : IDispatch {
        [id(00000000), propget, hidden]
        HRESULT _Action([out, retval] short* psAction);
        [id(00000000), propput, hidden]
        HRESULT _Action([in] short psAction);
        [id(0x00000001), propget, helpstring("Returns/sets the path and filename of a selected file."), helpcontext(0x00030da4)]
        HRESULT FileName([out, retval] BSTR* pbstrFileName);
        [id(0x00000001), propput, helpstring("Returns/sets the path and filename of a selected file."), helpcontext(0x00030da4)]
        HRESULT FileName([in] BSTR pbstrFileName);
        [id(0x00000002), propget, helpstring("Sets the string displayed in the title bar of the dialog box."), helpcontext(0x00030da5)]
        HRESULT DialogTitle([out, retval] BSTR* pbstrDialogTitle);
        [id(0x00000002), propput, helpstring("Sets the string displayed in the title bar of the dialog box."), helpcontext(0x00030da5)]
        HRESULT DialogTitle([in] BSTR pbstrDialogTitle);
        [id(0x00000003), propget, helpstring("Returns/sets the filters that are displayed in the Type list box of a dialog box."), helpcontext(0x00030da6)]
        HRESULT Filter([out, retval] BSTR* pbstrFilter);
        [id(0x00000003), propput, helpstring("Returns/sets the filters that are displayed in the Type list box of a dialog box."), helpcontext(0x00030da6)]
        HRESULT Filter([in] BSTR pbstrFilter);
        [id(0x00000004), propget, helpstring("Returns/sets the default filename extension for the dialog box."), helpcontext(0x00030da7)]
        HRESULT DefaultExt([out, retval] BSTR* pbstrDefaultExt);
        [id(0x00000004), propput, helpstring("Returns/sets the default filename extension for the dialog box."), helpcontext(0x00030da7)]
        HRESULT DefaultExt([in] BSTR pbstrDefaultExt);
        [id(0x00000005), propget, helpstring("Returns/sets the initial file directory."), helpcontext(0x00030da8)]
        HRESULT InitDir([out, retval] BSTR* pbstrInitDir);
        [id(0x00000005), propput, helpstring("Returns/sets the initial file directory."), helpcontext(0x00030da8)]
        HRESULT InitDir([in] BSTR pbstrInitDir);
        [id(0x00000006), propget, helpstring("Returns/sets the selected color."), helpcontext(0x00030da9)]
        HRESULT Color([out, retval] stdole.OLE_COLOR* clrColor);
        [id(0x00000006), propput, helpstring("Returns/sets the selected color."), helpcontext(0x00030da9)]
        HRESULT Color([in] stdole.OLE_COLOR clrColor);
        [id(0x00000007), propget, helpstring("Sets the options for a dialog box."), helpcontext(0x00030daa)]
        HRESULT Flags([out, retval] long* plFlags);
        [id(0x00000007), propput, helpstring("Sets the options for a dialog box."), helpcontext(0x00030daa)]
        HRESULT Flags([in] long plFlags);
        [id(0x00000008), propget, helpstring("Specifies the name of the font that appears in each row for the given level."), helpcontext(0x00030dab)]
        HRESULT FontName([out, retval] BSTR* pbstrFontName);
        [id(0x00000008), propput, helpstring("Specifies the name of the font that appears in each row for the given level."), helpcontext(0x00030dab)]
        HRESULT FontName([in] BSTR pbstrFontName);
        [id(0x00000009), propget, helpstring("Returns/sets bold font styles."), helpcontext(0x00030dac)]
        HRESULT FontBold([out, retval] VARIANT_BOOL* pbFontBold);
        [id(0x00000009), propput, helpstring("Returns/sets bold font styles."), helpcontext(0x00030dac)]
        HRESULT FontBold([in] VARIANT_BOOL pbFontBold);
        [id(0x0000000a), propget, helpstring("Returns/sets italic font styles."), helpcontext(0x00030dad)]
        HRESULT FontItalic([out, retval] VARIANT_BOOL* pbFontItalic);
        [id(0x0000000a), propput, helpstring("Returns/sets italic font styles."), helpcontext(0x00030dad)]
        HRESULT FontItalic([in] VARIANT_BOOL pbFontItalic);
        [id(0x0000000b), propget, helpstring("Returns/sets strikethrough font styles."), helpcontext(0x00030dae)]
        HRESULT FontStrikeThru([out, retval] VARIANT_BOOL* pbFontStrikeThru);
        [id(0x0000000b), propput, helpstring("Returns/sets strikethrough font styles."), helpcontext(0x00030dae)]
        HRESULT FontStrikeThru([in] VARIANT_BOOL pbFontStrikeThru);
        [id(0x0000000c), propget, helpstring("Returns/sets underline font styles."), helpcontext(0x00030daf)]
        HRESULT FontUnderLine([out, retval] VARIANT_BOOL* pbFontUnderLine);
        [id(0x0000000c), propput, helpstring("Returns/sets underline font styles."), helpcontext(0x00030daf)]
        HRESULT FontUnderLine([in] VARIANT_BOOL pbFontUnderLine);
        [id(0x0000000d), propget, helpstring("Returns/sets the value for the first page to be printed."), helpcontext(0x00030db0)]
        HRESULT FromPage([out, retval] short* psFromPage);
        [id(0x0000000d), propput, helpstring("Returns/sets the value for the first page to be printed."), helpcontext(0x00030db0)]
        HRESULT FromPage([in] short psFromPage);
        [id(0x0000000e), propget, helpstring("Returns/sets the value for the first page to be printed."), helpcontext(0x00030db1)]
        HRESULT ToPage([out, retval] short* psToPage);
        [id(0x0000000e), propput, helpstring("Returns/sets the value for the first page to be printed."), helpcontext(0x00030db1)]
        HRESULT ToPage([in] short psToPage);
        [id(0x0000000f), propget, helpstring("Sets the smallest allowable font size (Font dialog) or print range (Print dialog)."), helpcontext(0x00030db2)]
        HRESULT Min([out, retval] short* psMin);
        [id(0x0000000f), propput, helpstring("Sets the smallest allowable font size (Font dialog) or print range (Print dialog)."), helpcontext(0x00030db2)]
        HRESULT Min([in] short psMin);
        [id(0x00000010), propget, helpstring("Returns/sets the maximum font size (Font dialog) or print range (Print dialog)."), helpcontext(0x00030db3)]
        HRESULT Max([out, retval] short* psMax);
        [id(0x00000010), propput, helpstring("Returns/sets the maximum font size (Font dialog) or print range (Print dialog)."), helpcontext(0x00030db3)]
        HRESULT Max([in] short psMax);
        [id(0x00000011), propget, helpstring("Returns/sets a value that determines the number of copies to be printed."), helpcontext(0x00030db4)]
        HRESULT Copies([out, retval] short* psCopies);
        [id(0x00000011), propput, helpstring("Returns/sets a value that determines the number of copies to be printed."), helpcontext(0x00030db4)]
        HRESULT Copies([in] short psCopies);
        [id(0x00000012), propget, helpstring("Indicates whether an error is generated when the user chooses the Cancel button."), helpcontext(0x00030db5)]
        HRESULT CancelError([out, retval] VARIANT_BOOL* pbCancelError);
        [id(0x00000012), propput, helpstring("Indicates whether an error is generated when the user chooses the Cancel button."), helpcontext(0x00030db5)]
        HRESULT CancelError([in] VARIANT_BOOL pbCancelError);
        [id(0x00000013), propget, helpstring("Returns/sets the name of the Help file associated with the project."), helpcontext(0x00030db6)]
        HRESULT HelpFile([out, retval] BSTR* pbstrHelpFile);
        [id(0x00000013), propput, helpstring("Returns/sets the name of the Help file associated with the project."), helpcontext(0x00030db6)]
        HRESULT HelpFile([in] BSTR pbstrHelpFile);
        [id(0x00000014), propget, helpstring("Returns/sets the type of online Help requested."), helpcontext(0x00030db7)]
        HRESULT HelpCommand([out, retval] short* psHelpCommand);
        [id(0x00000014), propput, helpstring("Returns/sets the type of online Help requested."), helpcontext(0x00030db7)]
        HRESULT HelpCommand([in] short psHelpCommand);
        [id(0x00000015), propget, helpstring("Returns/sets the keyword that identifies the requested Help topic."), helpcontext(0x00030db8)]
        HRESULT HelpKey([out, retval] BSTR* pbstrHelpKey);
        [id(0x00000015), propput, helpstring("Returns/sets the keyword that identifies the requested Help topic."), helpcontext(0x00030db8)]
        HRESULT HelpKey([in] BSTR pbstrHelpKey);
        [id(0x00000016), propget, helpstring("Determines if user selections in the Print dialog box are used to change the default printer settings."), helpcontext(0x00030db9)]
        HRESULT PrinterDefault([out, retval] VARIANT_BOOL* pbPrinterDefault);
        [id(0x00000016), propput, helpstring("Determines if user selections in the Print dialog box are used to change the default printer settings."), helpcontext(0x00030db9)]
        HRESULT PrinterDefault([in] VARIANT_BOOL pbPrinterDefault);
        [id(0x00000017), propget, helpstring("Returns/sets a default filter for an Open or Save As dialog box."), helpcontext(0x00030dba)]
        HRESULT FilterIndex([out, retval] short* psFilterIndex);
        [id(0x00000017), propput, helpstring("Returns/sets a default filter for an Open or Save As dialog box."), helpcontext(0x00030dba)]
        HRESULT FilterIndex([in] short psFilterIndex);
        [id(0x00000018), propget, helpstring("Returns/sets the context ID of the requested Help topic."), helpcontext(0x00030dbb)]
        HRESULT HelpContext([out, retval] long* plHelpContext);
        [id(0x00000018), propput, helpstring("Returns/sets the context ID of the requested Help topic."), helpcontext(0x00030dbb)]
        HRESULT HelpContext([in] long plHelpContext);
        [id(0x00000019), propget, helpstring("Specifies the size (in points) of the font that appears in each row for the given level."), helpcontext(0x00030dbc)]
        HRESULT FontSize([out, retval] float* pfFontSize);
        [id(0x00000019), propput, helpstring("Specifies the size (in points) of the font that appears in each row for the given level."), helpcontext(0x00030dbc)]
        HRESULT FontSize([in] float pfFontSize);
        [id(0x0000001a), propget, helpstring("Returns/sets the type of dialog box to be displayed."), helpcontext(0x00030dbd)]
        HRESULT Action([out, retval] short* psAction);
        [id(0x0000001a), propput, helpstring("Returns/sets the type of dialog box to be displayed."), helpcontext(0x00030dbd)]
        HRESULT Action([in] short psAction);
        [id(0x0000001b), propget, helpstring("Returns/sets the maximum size of the filename opened using the CommonDialog control."), helpcontext(0x00030dbe)]
        HRESULT MaxFileSize([out, retval] short* psMaxFileSize);
        [id(0x0000001b), propput, helpstring("Returns/sets the maximum size of the filename opened using the CommonDialog control."), helpcontext(0x00030dbe)]
        HRESULT MaxFileSize([in] short psMaxFileSize);
        [id(0x0000001c), propget, helpstring("Returns a handle (from Microsoft Windows) to the object's device context."), helpcontext(0x00030dbf)]
        HRESULT hDC([out, retval] int* pihDC);
        [id(0x0000001c), propput, helpstring("Returns a handle (from Microsoft Windows) to the object's device context."), helpcontext(0x00030dbf)]
        HRESULT hDC([in] int pihDC);
        [id(0x0000001d), propget, helpstring("Returns/sets the name (without the path) of the file to open or save at run time."), helpcontext(0x00030dc0)]
        HRESULT FileTitle([out, retval] BSTR* pbstrFileTitle);
        [id(0x0000001d), propput, helpstring("Returns/sets the name (without the path) of the file to open or save at run time."), helpcontext(0x00030dc0)]
        HRESULT FileTitle([in] BSTR pbstrFileTitle);
        [id(0x0000001e), helpstring("Displays the CommonDialog control's Open dialog box."), helpcontext(0x00030dc1)]
        HRESULT ShowOpen();
        [id(0x0000001f), helpstring("Displays the CommonDialog control's Save As dialog box."), helpcontext(0x00030dc2)]
        HRESULT ShowSave();
        [id(0x00000020), helpstring("Displays the CommonDialog control's Color dialog box."), helpcontext(0x00030dc3)]
        HRESULT ShowColor();
        [id(0x00000021), helpstring("Displays the CommonDialog control's Font dialog box"), helpcontext(0x00030dc4)]
        HRESULT ShowFont();
        [id(0x00000022), helpstring("Displays the CommonDialog control's Printer dialog box."), helpcontext(0x00030dc5)]
        HRESULT ShowPrinter();
        [id(0x00000023), helpstring("Runs Winhelp.EXE and displays the Help file you specify."), helpcontext(0x00030dc6)]
        HRESULT ShowHelp();
        [id(0xfffffdd8), hidden]
        HRESULT AboutBox();
        [id(0x00000024), propget, helpstring("Returns/sets printer paper orientation"), helpcontext(0x00030dfe)]
        HRESULT Orientation([out, retval] PrinterOrientationConstants* pOrientation);
        [id(0x00000024), propput, helpstring("Returns/sets printer paper orientation"), helpcontext(0x00030dfe)]
        HRESULT Orientation([in] PrinterOrientationConstants pOrientation);
    };

    [
        uuid(F9043C87-F6F2-101A-A3C9-08002B2F49FB)
    ]
    dispinterface ICommonDialogEvents {
    properties:
    methods:
    };

    [
        uuid(F9043C85-F6F2-101A-A3C9-08002B2F49FB),
        helpstring("Microsoft Common Dialog Control 6.0 (SP3)"),
        helpcontext(0x00030d40),
        licensed,
        control
    ]
    coclass CommonDialog {
        [default] interface ICommonDialog;
        [default, source] dispinterface ICommonDialogEvents;
    };

    typedef [uuid(7FF19DC0-D9B3-11CF-8E74-00A0C90F26F8), public]
    ICommonDialog ICommonDialog11;

};